/* vim:ft=c ts=4 sw=4 nomodified:
 */
/**@file
 *			Patches for Anthy, by G-HAL
 *@brief	ʸڤꥢ르ꥺࡧʬ
 *@date		Wed,05 Nov,2008
 *@date		Sun,16 Nov,2008
 *@date		Tue,18 Nov,2008
 *@date		Thu,20 Nov,2008
 *@date		Mon,05 Jan,2009
 *@date		Sat,17 Jan,2009
 *@date		Mon,19 Jan,2009
 *@date		Sat,24 Jan,2009, Thu,29 Jan,2009
 *@date		Sun,08 Feb,2009 - Mon,09 Feb,2009
 *@date		Wed,25 Feb,2009
 *@date		Fri,06 Mar,2009
 *@date		Sat,18 Apr,2009
 *@date		Fri,01 May,2009
 *@author	Copyright(C)2008-2009 G-HAL
 */

#ifndef	_lattice_h_included_
#define	_lattice_h_included_

#include "anthy/xstr.h"
#include "anthy/splitter.h"
#include "src-splitter/wordborder.h"
#include "anthy/ordering.h"


#if defined(__cplusplus)
extern "C" {
#endif /* defined(__cplusplus) */



/** metaword ̻ͥ
 */
struct priority_of_metaword_pair_t {
	const int	pri;				/**< ͥ */
	const int	sub;				/**< sub-priority Ĥݤ */
};

/** metaword ͥ
 *
 *@note
 *	ʸڤ⡼ɤоݤˤäƤϡ̤βžΤ
 *
 *	CAND_HISTORYؽ OCHAIREؽиϡ
 *	ʸĹץ⡼ɻΤ߻Ѳǽ
 *	ʥӥӤǤϽ̤βžбʰ١ˡ
 *
 *	üʸڤʤϡ
 *	ʸĹץ⡼ɻΤ߻Ѳǽ
 *	ʥӥӤǤϱüǶڤʤʸбʰ١ˡ
 *
 *	MW_COMPOUND_*  ʸĹץ⡼ɻΤߤʤΤϡ
 *	ñ˥르ꥺνΰ㤤ؤб
 */
struct priority_of_metaword_t {
	const struct priority_of_metaword_pair_t	OCHAIRE_MIDDLE;					/**< (37)	OCHAIREؽΡɡʸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoD_MIDDLE;				/**< (36)	°̵OCHAIREؽΡɡʸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoI_MIDDLE;				/**< (35)	Ω̵OCHAIREؽΡɡʸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_MIDDLE;			/**< (34)	Ω졦°̵OCHAIREؽΡɡʸ */
	const struct priority_of_metaword_pair_t	CAND_COUNTER_MAXLIMIT;			/**< (29)	CAND_HISTORYؽ OCHAIREؽйξ¡ʣʸĹץ⡼ɻΤߡ */
	const struct priority_of_metaword_pair_t	CAND_COUNTER_MAXLIMIT_VALUE;	/**< (25)	CAND_COUNTER_MAXLIMITŬѤ줿Ѥͥ١ʣʸĹץ⡼ɻΤߡ */
	const struct priority_of_metaword_pair_t	OCHAIRE_HEAD;					/**< (17)-1	OCHAIREؽΡɡƬʸ
																				 *   (17)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ */
	const struct priority_of_metaword_pair_t	OCHAIREwoD_HEAD;				/**< (16)-1	°̵OCHAIREؽΡɡƬʸ
																				 *   (16)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ */
	const struct priority_of_metaword_pair_t	OCHAIRE_TAIL;					/**< (15)-1	OCHAIREؽΡɡǸʸ
																				 *   (15)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	OCHAIRE_SINGLE;					/**< (14)-1	OCHAIREؽΡɡƬǤĺǸ
																				 *   (14)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	OCHAIREwoI_TAIL;				/**< (14)-1	Ω̵OCHAIREؽΡɡǸʸ
																				 *   (14)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	OCHAIREwoD_TAIL;				/**< (13)-1	°̵OCHAIREؽΡɡǸʸ
																				 *   (13)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_TAIL;				/**< (12)-1	Ω졦°̵OCHAIREؽΡɡǸʸ
																				 *   (12)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	OCHAIREwoD_SINGLE;				/**< (11)-1	°̵OCHAIREؽΡɡƬǤĺǸ
																				 *   (11)-2	CAND_HISTORYؽΡɤ OCHAIREй׷Ƥ
																				 */
	const struct priority_of_metaword_pair_t	CAND_STRONGMODE;				/**< (11)-3	CAND_HISTORYؽΡ(true == anthy_settings.anthy_mode.lattice.with_candhistory) */
	const struct priority_of_metaword_pair_t	CAND_COUNTER_MINLIMIT;			/**< (10)	CAND_HISTORYؽ OCHAIREؽй򳫻Ϥ벼¡ʣʸĹץ⡼ɻΤߡ */
	const struct priority_of_metaword_pair_t	CAND_WEAKMODE;					/**< (5)	CAND_HISTORYؽΡ(false == anthy_settings.anthy_mode.lattice.with_candhistory) */
	const struct priority_of_metaword_pair_t	DEFAULT;						/**< (5)	ƥ༭񤫤Ρɡ¾ */
	const struct priority_of_metaword_pair_t	COMPOUNDHEAD;					/**< (5)	ƥ༭񤫤ΡɡMW_COMPOUND_HEAD */
	const struct priority_of_metaword_pair_t	COMPOUNDPART;					/**< (4)	ƥ༭񤫤ΡɡMW_COMPOUND_PART */
	const struct priority_of_metaword_pair_t	COMPOUND;						/**< (2)	ƥ༭񤫤ΡɡMW_COMPOUND */
	const struct priority_of_metaword_pair_t	COMPOUNDLEAF;					/**< (1)	ƥ༭񤫤ΡɡMW_COMPOUND_LEAF */
	const struct priority_of_metaword_pair_t	OCHAIREwoI_HEAD;				/**< (0)	Ω̵OCHAIREؽΡɡƬʸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_HEAD;				/**< (0)	Ω졦°̵OCHAIREؽΡɡƬʸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoI_SINGLE;				/**< (0)	Ω̵OCHAIREؽΡɡƬǤĺǸ */
	const struct priority_of_metaword_pair_t	OCHAIREwoIwoD_SINGLE;			/**< (0)	Ω졦°̵OCHAIREؽΡɡƬǤĺǸ */
	const struct priority_of_metaword_pair_t	DELETEDHISTORY;					/**< (0)	ޡդؽ */
};



extern int calc_metaword_score( const struct splitter_context* const sc,
							   struct meta_word* const mw,
							   const struct meta_word* const prev_mw );

extern int calc_cmpnode_priority( const struct priority_of_metaword_t* const pri,
								 struct meta_word* const mw,
								 int cmp_priority,
								 int cmp_minlen,
								 int* const have_sub_priority,
								 int* const ret_minlen );


extern void choose_path_by_maxlen_n_phrases( struct splitter_context* const sc,
											size_t from, size_t to );
extern void choose_path_by_manual( struct splitter_context* const sc,
								  size_t from, size_t to );
extern void hinted_path_by_manual( struct splitter_context* const sc,
								  size_t from, size_t to );


#if defined(__cplusplus)
}
#endif /* defined(__cplusplus) */

#endif /* _lattice_h_included_ */
/* [ End of File ] */
